#Connor Skorge - Final Project
import board, time, neopixel, random, digitalio
from audiocore import WaveFile
from adafruit_apds9960.apds9960 import APDS9960
from adafruit_led_animation.animation.comet import Comet
from adafruit_led_animation.animation.SparklePulse import SparklePulse
from adafruit_led_animation.animation.colorcycle import ColorCycle


from adafruit_led_animation.color import (
    AMBER, #(255, 100, 0)
    AQUA, # (50, 255, 255)
    BLACK, #OFF (0, 0, 0)
    BLUE, # (0, 0, 255)
    CYAN, # (0, 255, 255)
    GOLD, # (255, 222, 30)
    GREEN, # (0, 255, 0)
    JADE, # (0, 255, 40)
    MAGENTA, #(255, 0, 20)
    OLD_LACE, # (253, 245, 230)
    ORANGE, # (255, 40, 0)
    PINK, # (242, 90, 255)
    PURPLE, # (180, 0, 255)
    RED, # (255, 0, 0)
    TEAL, # (0, 255, 120)
    WHITE, # (255, 255, 255)
    YELLOW, # (255, 150, 0)
    RAINBOW # a list of colors to cycle through
    # RAINBOW is RED, ORANGE, YELLOW, GREEN, BLUE, and PURPLE ((255, 0, 0), (255, 40, 0), (255, 150, 0), (0, 255, 0), (0, 0, 255), (180, 0, 255))
)

INDIGO=(63,0,255)
VIOLET=(127,0,255)
MAROON = (128, 0, 0)

colors = [RED,WHITE,GOLD]

strip_pin = board.D7
strip_num_of_lights = 30
strip = neopixel.NeoPixel(strip_pin, strip_num_of_lights, brightness = 1, auto_write = True)

from adafruit_apds9960.apds9960 import APDS9960
i2c = board.I2C()
multi_sensor = APDS9960(i2c)
multi_sensor.enable_proximity = True

try:
    from audioio import AudioOut
except ImportError:
    try:
        from audiopwmio import PWMAudioOut as AudioOut
    except ImportError:
        print("this board does not support audioout")
        pass

comet_strip = Comet(strip, speed=0.05, color=RED, tail_length=int(strip_num_of_lights/4), bounce=True)
sparkle_pulse_strip = SparklePulse(strip, speed = 0.05, period = 5, color = CYAN)
colorcycle_strip = ColorCycle(strip, 0.1, colors = colors)

hoop_sounds = ["2-points.wav", "cheer.wav", "what-a-shot.wav", "3-points.wav"]

audio = AudioOut(board.D2)
path = "basketball-hoop/"

def play_sound_1(filename):
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing:
            comet_strip.animate()
            pass

def play_sound_2(filename):
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing:
            colorcycle_strip.animate()
            pass


play_sound_1("start.wav")
while True:
    reading = multi_sensor.proximity
    print((reading,))
    time.sleep(.05)
    if reading == 50 or reading < 50:
        sparkle_pulse_strip.animate()
    if reading > 1:
        random_number = random.randint(-1,3)
        play_sound_2(hoop_sounds[random_number])
